/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * PolicySubscription
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class PolicySubscription {
  @SerializedName("partner_key")
  private String partnerKey = null;

  @SerializedName("context")
  private Context context = null;

  @SerializedName("product_code")
  private String productCode = null;

  @SerializedName("product_price")
  private BigDecimal productPrice = null;

  @SerializedName("policy_holder")
  private Model142 policyHolder = null;

  @SerializedName("beneficiaries")
  private Model145 beneficiaries = null;

  @SerializedName("payment_method_id")
  private String paymentMethodId = null;

  @SerializedName("travel_information")
  private Model147 travelInformation = null;

  @SerializedName("optional_travel_information")
  private OptionalTravelInformation optionalTravelInformation = null;

  @SerializedName("undefined_criteria")
  private UndefinedCriteria undefinedCriteria = null;

  public PolicySubscription partnerKey(String partnerKey) {
    this.partnerKey = partnerKey;
    return this;
  }

   /**
   * Universally unique identifier (UUID) of the partner
   * @return partnerKey
  **/
  @ApiModelProperty(example = "Partner Alpha", required = true, value = "Universally unique identifier (UUID) of the partner")
  public String getPartnerKey() {
    return partnerKey;
  }

  public void setPartnerKey(String partnerKey) {
    this.partnerKey = partnerKey;
  }

  public PolicySubscription context(Context context) {
    this.context = context;
    return this;
  }

   /**
   * Get context
   * @return context
  **/
  @ApiModelProperty(value = "")
  public Context getContext() {
    return context;
  }

  public void setContext(Context context) {
    this.context = context;
  }

  public PolicySubscription productCode(String productCode) {
    this.productCode = productCode;
    return this;
  }

   /**
   * Unique name of the selected product. This value is usually communicated to you by AXA Assistance
   * @return productCode
  **/
  @ApiModelProperty(example = "product1", required = true, value = "Unique name of the selected product. This value is usually communicated to you by AXA Assistance")
  public String getProductCode() {
    return productCode;
  }

  public void setProductCode(String productCode) {
    this.productCode = productCode;
  }

  public PolicySubscription productPrice(BigDecimal productPrice) {
    this.productPrice = productPrice;
    return this;
  }

   /**
   * Price of the selected product (only for integrated channel), for reporting purposes
   * minimum: 0
   * @return productPrice
  **/
  @ApiModelProperty(example = "0.0", value = "Price of the selected product (only for integrated channel), for reporting purposes")
  public BigDecimal getProductPrice() {
    return productPrice;
  }

  public void setProductPrice(BigDecimal productPrice) {
    this.productPrice = productPrice;
  }

  public PolicySubscription policyHolder(Model142 policyHolder) {
    this.policyHolder = policyHolder;
    return this;
  }

   /**
   * Get policyHolder
   * @return policyHolder
  **/
  @ApiModelProperty(value = "")
  public Model142 getPolicyHolder() {
    return policyHolder;
  }

  public void setPolicyHolder(Model142 policyHolder) {
    this.policyHolder = policyHolder;
  }

  public PolicySubscription beneficiaries(Model145 beneficiaries) {
    this.beneficiaries = beneficiaries;
    return this;
  }

   /**
   * Get beneficiaries
   * @return beneficiaries
  **/
  @ApiModelProperty(value = "")
  public Model145 getBeneficiaries() {
    return beneficiaries;
  }

  public void setBeneficiaries(Model145 beneficiaries) {
    this.beneficiaries = beneficiaries;
  }

  public PolicySubscription paymentMethodId(String paymentMethodId) {
    this.paymentMethodId = paymentMethodId;
    return this;
  }

   /**
   * Identifier of payment
   * @return paymentMethodId
  **/
  @ApiModelProperty(example = "SDFG14598", value = "Identifier of payment")
  public String getPaymentMethodId() {
    return paymentMethodId;
  }

  public void setPaymentMethodId(String paymentMethodId) {
    this.paymentMethodId = paymentMethodId;
  }

  public PolicySubscription travelInformation(Model147 travelInformation) {
    this.travelInformation = travelInformation;
    return this;
  }

   /**
   * Get travelInformation
   * @return travelInformation
  **/
  @ApiModelProperty(value = "")
  public Model147 getTravelInformation() {
    return travelInformation;
  }

  public void setTravelInformation(Model147 travelInformation) {
    this.travelInformation = travelInformation;
  }

  public PolicySubscription optionalTravelInformation(OptionalTravelInformation optionalTravelInformation) {
    this.optionalTravelInformation = optionalTravelInformation;
    return this;
  }

   /**
   * Get optionalTravelInformation
   * @return optionalTravelInformation
  **/
  @ApiModelProperty(value = "")
  public OptionalTravelInformation getOptionalTravelInformation() {
    return optionalTravelInformation;
  }

  public void setOptionalTravelInformation(OptionalTravelInformation optionalTravelInformation) {
    this.optionalTravelInformation = optionalTravelInformation;
  }

  public PolicySubscription undefinedCriteria(UndefinedCriteria undefinedCriteria) {
    this.undefinedCriteria = undefinedCriteria;
    return this;
  }

   /**
   * Get undefinedCriteria
   * @return undefinedCriteria
  **/
  @ApiModelProperty(value = "")
  public UndefinedCriteria getUndefinedCriteria() {
    return undefinedCriteria;
  }

  public void setUndefinedCriteria(UndefinedCriteria undefinedCriteria) {
    this.undefinedCriteria = undefinedCriteria;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PolicySubscription policySubscription = (PolicySubscription) o;
    return Objects.equals(this.partnerKey, policySubscription.partnerKey) &&
        Objects.equals(this.context, policySubscription.context) &&
        Objects.equals(this.productCode, policySubscription.productCode) &&
        Objects.equals(this.productPrice, policySubscription.productPrice) &&
        Objects.equals(this.policyHolder, policySubscription.policyHolder) &&
        Objects.equals(this.beneficiaries, policySubscription.beneficiaries) &&
        Objects.equals(this.paymentMethodId, policySubscription.paymentMethodId) &&
        Objects.equals(this.travelInformation, policySubscription.travelInformation) &&
        Objects.equals(this.optionalTravelInformation, policySubscription.optionalTravelInformation) &&
        Objects.equals(this.undefinedCriteria, policySubscription.undefinedCriteria);
  }

  @Override
  public int hashCode() {
    return Objects.hash(partnerKey, context, productCode, productPrice, policyHolder, beneficiaries, paymentMethodId, travelInformation, optionalTravelInformation, undefinedCriteria);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PolicySubscription {\n");
    
    sb.append("    partnerKey: ").append(toIndentedString(partnerKey)).append("\n");
    sb.append("    context: ").append(toIndentedString(context)).append("\n");
    sb.append("    productCode: ").append(toIndentedString(productCode)).append("\n");
    sb.append("    productPrice: ").append(toIndentedString(productPrice)).append("\n");
    sb.append("    policyHolder: ").append(toIndentedString(policyHolder)).append("\n");
    sb.append("    beneficiaries: ").append(toIndentedString(beneficiaries)).append("\n");
    sb.append("    paymentMethodId: ").append(toIndentedString(paymentMethodId)).append("\n");
    sb.append("    travelInformation: ").append(toIndentedString(travelInformation)).append("\n");
    sb.append("    optionalTravelInformation: ").append(toIndentedString(optionalTravelInformation)).append("\n");
    sb.append("    undefinedCriteria: ").append(toIndentedString(undefinedCriteria)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

